const { keyName } = require('w3c-keyname');

const executeKeyHandler = (key, keyEvent, pstate, cm) => {
    return (keyEvent[key] || keyEvent.nop).fn(pstate, cm);
};

const genKeyHandler = (div, pstate, deso, cm, keyEvent, plugins) => {
    return event => {

        const modifier = (
            (event.ctrlKey ? 'Ctrl+' : '') +
            (event.shiftKey ? 'Shift+' : '') +
            (event.altKey ? 'Alt+' : '')
        );
        // const key = modifier + event.key;
        const key = modifier + keyName(event);

        if (executeKeyHandler(key, keyEvent, pstate, cm)) {
            event.stopPropagation();
            if (plugins != undefined) {
                plugins.map(fn => fn(key, event));
            }
            deso.render();
        }
    };
};

export default {
    executeKeyHandler,
    genKeyHandler
};