const genOnWheel = (element, pstate, deso, keyEvent, plugins) =>
    event => {
        const { deltaX, deltaY } = event;
        if (event.ctrlKey) {
            const key = (deltaY < 0)
                ? 'Ctrl+icon:scrollUp'
                : ((deltaY > 0) ? 'Ctrl+icon:scrollDown' : 'nop');
            if (keyEvent[key].fn(pstate)) {
                if (plugins != undefined) {
                    plugins.map(fn => fn(key, event));
                }
                deso.render({ type: 'action' });
            }
            event.preventDefault();
        } else if (event.shiftKey) {
            const key = (deltaY < 0) ? 'Shift+icon:scrollUp' : ((deltaY > 0) ? 'Shift+icon:scrollDown' : 'nop');
            if (keyEvent[key].fn(pstate)) {
                if (plugins != undefined) {
                    plugins.map(fn => fn(key, event));
                }
                deso.render({ type: 'action' });
            }
            event.preventDefault();
        } else if (deltaX !== 0 && deltaY === 0) {
            const key = (deltaX < 0) ? 'scrollLeft': 'scrollRight';
            if (keyEvent[key].fn(pstate)) {
                if (plugins != undefined) {
                    plugins.map(fn => fn(key, event));
                }
                deso.render({ type: 'action' });
            }
            event.preventDefault();
        } else if (deltaX === 0 && deltaY !== 0) {
            const key = (deltaY < 0) ? 'scrollUp': 'scrollDown';
            if (keyEvent[key].fn(pstate)) {
                if (plugins != undefined) {
                    plugins.map(fn => fn(key, event));
                }
                deso.render({ type: 'action' });
            }
            event.preventDefault();
        }
    };

export default genOnWheel;