import xOffsetUpdate from './x-offset-update';

const genResizeHandler = pstate =>
    (width, height) => {
        let { xOffset, yOffset, xScale, yStep, time, sidebarWidth, numLanes } = pstate;
        pstate.width = width;
        pstate.height = height;

        // Y
        const yOffsetMax = (numLanes + 2) * 2 * yStep;
        if (yOffsetMax < 0) {
            yOffset = 0;
        } else if (yOffset > yOffsetMax) {
            yOffset = yOffsetMax;
        }
        pstate.yOffset = yOffset;

        const xScaleMin = pstate.xScaleMin = 0.001;
        pstate.xScale = (xScale < xScaleMin) ? xScaleMin : xScale;
        xOffsetUpdate(pstate, () => xOffset);
    };

export default genResizeHandler;
