import { globalStyle, globalLookup } from '../global';

const yOffsetUpdate = (pstate, nextOffsetYFn) => {
    let nextOffsetY = nextOffsetYFn();
    const { width, xOffset, xScale, time, sidebarWidth } = pstate;

    const currentRenderHeight = globalLookup.currentWires.size * pstate.yStep;
    const canvasHeight = pstate.height - pstate.topBarHeight - pstate.botBarHeight;
    console.log(currentRenderHeight, canvasHeight);
    const maxOffsetX = Math.max(-40, currentRenderHeight - canvasHeight); // maximum offset
    nextOffsetY = Math.min(nextOffsetY, maxOffsetX);

    const minOffsetX = -40; // minimum offset
    nextOffsetY = Math.max(nextOffsetY, minOffsetX);
    
    if (nextOffsetY === xOffset) {
        return false; // exit without scroll
    }
    
    console.log('next offset y', nextOffsetY);

    pstate.oldYOffset = pstate.yOffset;
    pstate.yOffset = nextOffsetY;

    // 这玩意儿初始设置 -40 的偏移，当作 padding-top
    globalStyle.yOffset = nextOffsetY + 40;
    return true;
};

export default yOffsetUpdate;